unit KeyInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons;

type
  TFKI = Class(TForm)
    ValueLabel: TLabel;
    ShiftLabel: TLabel;
    CharLabel: TLabel;
    Panel1: TPanel;
    Panel3: TPanel;
    Panel5: TPanel;
    Panel7: TPanel;
    CloseBitBtn1: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label7: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Edit1: TEdit;
    procedure FormKeyDown(Sender:TObject;var Key:Word;Shift:TShiftState);
    procedure FormKeyPress(Sender:TObject;var Key:Char);
    procedure FormKeyUp(Sender:TObject;var Key:Word;Shift:TShiftState);
    procedure CharLabelClick(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure ShiftLabelClick(Sender: TObject);
    procedure ValueLabelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FKI: TFKI;

implementation

{$R *.DFM}

const
  ctrl_A=1;   // ASCII  <Ctrl+A)
  ctrl_z=26;  // ASCII  <Ctrl+Z)
// FunctioKeys
  FunctionKeys: array [vk_f1 .. vk_f12] of string[3]=
    ('F1', 'F2', 'F3', 'F4', 'F5', 'F6', 'F7', 'F8',
     'F9' ,'F10' ,'F11', 'F12');

procedure TFKIFormKeyDown(Sender:TObject;var Key:Word;Shift:TShiftState);
var
  s:string;
begin
// Key
  ValueLabel.Caption:=IntToStr(Key);
//   
  s:='';
  if ssShift  in Shift then s:=s+'Shift+'; //  
  if ssAlt    in Shift then s:=s+'Alt+';   // 
  if ssCtrl   in Shift then s:=s+'Ctrl+';  // Ctrk, Alt, Shift
  if Length(s)>0 then
    Delete(s, Length(s), 1); //  '+'
  ShiftLabel.Caption:=s;
//  
  if Key in [vk_f1 .. vk_f12] then
    CharLabel.Caption:=FunctionKeys[Key] //     
  else
    CharLabel.Caption:='';
//        Close
  if Key=vk_space then
    Key:=0;
end;

procedure TFKI.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Ord(Key) in [ctrl_A .. ctrl_z] then
    CharLabel.Caption:=Chr(Ord(Key)+Ord('A")-1)
  else
    CharLabel.Caption:=Key;
  ValueLabel.Caption:=IntToStr(Ord(Key));
end;

procedure TFKI.FormKeyUp(Sender: TOject; var Key: Word;
  Shift: TShiftState);
begin
  CharLabel.Caption:='';
  ValueLabel.Caption:='';
  ShiftLabel.Caption:='';
end;
procedure TFKI.CharLabelClick(Sender: TObject);
begin
//
end;

procedure TFKI.Panel1Click(Sender: TObject);
begin
//
end;

procedure TFKI.ShiftLabelClick(Sender: TObject);
begin
//
end;

procedure TFKI.ValueLabelClick(Sender: TObject);
begin
//
end;

end.
